import * as monaco from 'monaco-editor';
import { EmacsExtension } from './';
export declare type EditorCommand = {
    action?: string | string[];
    description?: string;
    run?: (editor: monaco.editor.IStandaloneCodeEditor, extension: EmacsExtension, repeat: number, repeatedTrigger: boolean) => void;
};
export interface ICommandMapping {
    [key: string]: EditorCommand;
}
export declare const prefixPreservingKeys: {
    "M-g": boolean;
    "C-x": boolean;
    "C-q": boolean;
    "C-u": boolean;
};
export declare const COMMANDS: ICommandMapping;
export declare function executeCommand(ext: EmacsExtension, command: EditorCommand, inputBuffer: string, repeatedTrigger: boolean): void;
export declare function registerGlobalCommand(key: string, command: EditorCommand): void;
export declare function unregisterKey(key: string): void;
export declare function getAllMappings(): {
    [key: string]: string;
};
