import * as monaco from 'monaco-editor';
export declare const modifierKeys: {
    [key: string]: string;
};
export declare function monacoToEmacsKey(ev: monaco.IKeyboardEvent): string;
export interface Event<T> {
    (listener: (e: T) => any, thisArgs?: any, disposables?: monaco.IDisposable[]): monaco.IDisposable;
}
export declare namespace Event {
    const None: Event<any>;
}
export declare class Emitter<T> implements monaco.Emitter<T> {
    private _event;
    private _disposed;
    private _listeners;
    get event(): Event<T>;
    fire(ev?: T): any;
    dispose(): void;
}
